<template>
  <div class="container shadow-2 bg-white" style="color: #757575">
    <ri-header :menu="0"></ri-header>
    <input-rep @country="countryInput" />
    <div class="row">
      <div class="col-6 q-pa-md">
        <line-chart
          :data="input"
          :ecoName="ecoName"
          :si="lineSI"
          :ci="lineCI"
        />
      </div>
      <div class="col-6 q-pa-md">
        <dim-chart
          :data="input"
          :ecoName="ecoName"
          :data1="dimYearSI1"
          :data2="dimYearSI2"
          :data3="dimYearCI1"
          :data4="dimYearCI2"
        />
      </div>
    </div>
    <div class="text-h6" align="center">
      <div v-if="ecoName == 'Asia-Pacific'">
        Which Asia-Pacific economies were most integrated with the rest of the
        region in {{ yearEnd }}? - Stylized honeycomb map of the Asia-Pacific
        region
      </div>
      <div v-if="ecoName != 'Asia-Pacific'">
        Which Asia-Pacific economies were most integrated with {{ ecoName }} in
        {{ yearEnd }}? – Sylized honeycomb map of the Asia-Pacific region
      </div>
    </div>
    <div class="row q-pt-md">
      <div class="col-6" align="center">
        <div class="text-h6">Sustainable integration</div>
        <div>Hover to reveal the country's name and integration score</div>
        <div class="q-pa-md">
          <tile-mapsi :data="input" />
        </div>
      </div>
      <div class="col-6" align="center">
        <div class="text-h6">Conventional integration</div>
        <div>Hover to reveal the country's name and integration score</div>
        <div class="q-pa-md">
          <tile-mapci :data="input" />
        </div>
      </div>
    </div>
    <div align="center">
      <div class="text-h6">
        Learn more about integration in Asia and the Pacific:
      </div>
      <div class="q-pt-md">
        <div class="row justify-center">
          <div style="width: 250px">
            <q-btn
              label="Country brief"
              class="btn"
              outline
              color="secondary"
              @click="goTOCountryBrief()"
            />
          </div>
          <div style="width: 250px">
            Eveything you need to know in<br />
            a handy 2-page format
          </div>
        </div>
      </div>
      <div class="q-py-md">
        Explore integration from different prespectives with our interactive web
        tool:
      </div>
      <div class="row justify-center">
        <div>
          <div class="row bigBtn cursor-pointer" @click="goToInra()">
            <div style="width: 100px" class="q-pt-sm">
              <img src="../../public/intra-g.svg" alt="" />
            </div>
            <div class="text-secondary q-pt-md q-pl-md" style="font-size: 16px">
              Intra-group<br />integration
            </div>
          </div>
          <div>
            Symmetric integration between<br />
            a group of economies
          </div>
        </div>
        <div style="width: 20px"></div>
        <div>
          <div class="row bigBtn cursor-pointer" @click="goToEco()">
            <div style="width: 100px; padding-top: 13px">
              <img src="../../public/eco-g.svg" alt="" />
            </div>
            <div class="text-secondary q-pt-md q-pl-md" style="font-size: 16px">
              Economy-partner<br />integration
            </div>
          </div>
          <div>
            Asymmetric integration between<br />
            different economies
          </div>
        </div>
        <div style="width: 20px"></div>
        <div>
          <div class="row bigBtn cursor-pointer" @click="goToBuild()">
            <div style="width: 100px; padding-top: 13px">
              <img src="../../public/build-g.svg" alt="" />
            </div>
            <div
              class="text-secondary q-pl-md"
              style="font-size: 16px; padding-top: 27px"
            >
              Build your own
            </div>
          </div>
          <div>
            Customize your integration index —<br />
            choose specific dimensions
          </div>
        </div>
      </div>
    </div>
    <div style="height: 30px"></div>
    <my-footer></my-footer>
  </div>
</template>

<script>
import axios from "axios";
import riHeader from "../components/ri/main/ri_header";
import myFooter from "../components/ri_footer";
import inputRep from "../components/ri/overview/select_reporter.vue";
import lineChart from "../components/ri/overview/line_chart.vue";
import dimChart from "../components/ri/overview/dim_chart.vue";
import tileMapsi from "../components/ri/overview/tiledmapSI.vue";
import tileMapci from "../components/ri/overview/tiledmapCI.vue";
import { setTimeout } from "timers";

export default {
  components: {
    riHeader,
    myFooter,
    inputRep,
    lineChart,
    dimChart,
    tileMapsi,
    tileMapci,
  },
  data() {
    return {
      input: [],
      ecoName: "",
      partner: [
        "AFG",
        "ARM",
        "ASM",
        "AZE",
        "COK",
        "FJI",
        "FSM",
        "GEO",
        "GUM",
        "IRN",
        "KAZ",
        "KGZ",
        "KIR",
        "MDV",
        "MHL",
        "MNP",
        "NCL",
        "NIU",
        "NRU",
        "PAK",
        "PLW",
        "PYF",
        "SLB",
        "TJK",
        "TKM",
        "TLS",
        "TON",
        "TUR",
        "TUV",
        "UZB",
        "VUT",
        "WSM",
        "PNG",
        "RUS",
        "KHM",
        "IDN",
        "PHL",
        "LAO",
        "BTN",
        "NPL",
        "BGD",
        "IND",
        "LKA",
        "MMR",
        "THA",
        "AUS",
        "NZL",
        "BRN",
        "MYS",
        "SGP",
        "VNM",
        "MAC",
        "PRK",
        "HKG",
        "MNG",
        "CHN",
        "KOR",
        "JPN",
      ],
      dimFinalSI: [],
      dimYearSI: [],
      dimYearSI1: [],
      dimYearSI2: [],
      dimFinalCI: [],
      dimYearCI: [],
      dimYearCI1: [],
      dimYearCI2: [],

      lineSI: [],
      lineCI: [],
      yearStart: "",
      yearEnd: "",
      yearHL: "",
      yearHH: "",
    };
  },
  methods: {
    goTOCountryBrief() {
      this.$router.push("/ricountrybrief");
    },
    goToInra() {
      this.$router.push("/riintragroup");
    },
    goToEco() {
      this.$router.push("/rieconomypartner");
    },
    goToBuild() {
      this.$router.push("/ribuildyourown");
    },
    async countryInput(input) {
      this.input = input.countryOutput;
      this.ecoName = input.ecoName;
      this.loadDimCal();
      this.loadDimLeft();
      await this.loadLineChart();
    },

    async loadDimCal() {
      let input = {
        year: {
          min: this.getStartYear(),
          max: this.getEndYear(),
        },
        type: "Sustainable",
      };
      let data6 = {
        input: input,
        countryPartnerList: "xxx",
        countryReportList: "xxx",
        partnerMap: this.partner,
        reportMap: this.input,
      };

      let url6 = this.ri_api + "economy/intra_index_by_dimension.php";
      let res6 = await axios.post(url6, JSON.stringify(data6));
      let dimRaw = res6.data;

      this.dimFinalSI = [];
      for (let dimCount = 1; dimCount <= 7; dimCount++) {
        for (
          let yearCount = this.yearStart;
          yearCount <= this.yearEnd;
          yearCount++
        ) {
          let dimTemp = dimRaw.filter(
            (data) =>
              Number(data.dimension) == dimCount &&
              Number(data.year) == yearCount
          );
          let dimTemp2 =
            dimTemp.reduce((a, b) => a + Number(b.score), 0) / dimTemp.length;
          let dataTemp = {
            dimension: dimCount,
            score: dimTemp2,
            year: yearCount,
          };
          this.dimFinalSI.push(dataTemp);
        }
      }

      this.dimYearSI = [];
      for (let dimCount = 1; dimCount <= 7; dimCount++) {
        let dimTemp1 = this.dimFinalSI.filter(
          (x) => x.year <= this.getHalfLowYear() && x.dimension == dimCount
        );

        let dimFinal1 =
          dimTemp1.reduce((a, b) => a + b.score, 0) / dimTemp1.length;
        let temp1 = {
          dimension: dimCount,
          score: dimFinal1,
          year: this.getStartYear() + "-" + this.getHalfLowYear(),
        };

        this.dimYearSI.push(temp1);
        let dimTemp2 = this.dimFinalSI.filter(
          (x) => x.year >= this.getHalfHighYear() && x.dimension == dimCount
        );
        let dimFinal2 =
          dimTemp2.reduce((a, b) => a + b.score, 0) / dimTemp2.length;
        let temp2 = {
          dimension: dimCount,
          score: dimFinal2,
          year: this.getHalfHighYear() + "-" + this.getEndYear(),
        };

        this.dimYearSI.push(temp2);
      }
      {
        let temp1 = this.dimYearSI.filter(
          (x) => x.year == this.getStartYear() + "-" + this.getHalfLowYear()
        );
        temp1.sort((a, b) => a.dimension - b.dimension);
        this.dimYearSI1 = temp1.map((x) => Number(x.score.toFixed(2)));
      }
      {
        let temp1 = this.dimYearSI.filter(
          (x) => x.year == this.getHalfHighYear() + "-" + this.getEndYear()
        );
        temp1.sort((a, b) => a.dimension - b.dimension);
        this.dimYearSI2 = temp1.map((x) => Number(x.score.toFixed(2)));
      }
    },

    async loadDimLeft() {
      let input = {
        year: {
          min: this.getStartYear(),
          max: this.getEndYear(),
        },
        type: "Conventional",
      };
      let data6 = {
        input: input,
        countryPartnerList: "xxx",
        countryReportList: "xxx",
        partnerMap: this.partner,
        reportMap: this.input,
      };

      let url6 = this.ri_api + "economy/intra_index_by_dimension.php";
      let res6 = await axios.post(url6, JSON.stringify(data6));
      let dimRaw = res6.data;

      this.dimFinalCI = [];
      for (let dimCount = 1; dimCount <= 7; dimCount++) {
        for (
          let yearCount = this.getStartYear();
          yearCount <= this.getEndYear();
          yearCount++
        ) {
          let dimTemp = dimRaw.filter(
            (data) =>
              Number(data.dimension) == dimCount &&
              Number(data.year) == yearCount
          );
          let dimTemp2 =
            dimTemp.reduce((a, b) => a + Number(b.score), 0) / dimTemp.length;
          let dataTemp = {
            dimension: dimCount,
            score: dimTemp2,
            year: yearCount,
          };
          this.dimFinalCI.push(dataTemp);
        }
      }

      this.dimYearCI = [];
      for (let dimCount = 1; dimCount <= 7; dimCount++) {
        let dimTemp1 = this.dimFinalCI.filter(
          (x) => x.year <= this.getHalfLowYear() && x.dimension == dimCount
        );

        let dimFinal1 =
          dimTemp1.reduce((a, b) => a + b.score, 0) / dimTemp1.length;
        let temp1 = {
          dimension: dimCount,
          score: dimFinal1,
          year: this.getStartYear() + "-" + this.getHalfLowYear(),
        };
        this.dimYearCI.push(temp1);
        let dimTemp2 = this.dimFinalCI.filter(
          (x) => x.year >= this.getHalfHighYear() && x.dimension == dimCount
        );
        let dimFinal2 =
          dimTemp2.reduce((a, b) => a + b.score, 0) / dimTemp2.length;
        let temp2 = {
          dimension: dimCount,
          score: dimFinal2,
          year: this.getHalfHighYear() + "-" + this.getEndYear(),
        };
        this.dimYearCI.push(temp2);
      }
      {
        let temp1 = this.dimYearCI.filter(
          (x) => x.year == this.getStartYear() + "-" + this.getHalfLowYear()
        );
        temp1.sort((a, b) => a.dimension - b.dimension);
        this.dimYearCI1 = temp1.map((x) => Number(x.score.toFixed(2)));
      }

      {
        let temp1 = this.dimYearCI.filter(
          (x) => x.year == this.getHalfHighYear() + "-" + this.getEndYear()
        );
        temp1.sort((a, b) => a.dimension - b.dimension);
        this.dimYearCI2 = temp1.map((x) => Number(x.score.toFixed(2)));
      }
      console.log(this.dimYearCI1);
      console.log(this.dimYearCI2);
    },
    async loadLineChart() {
      this.loadingShow();
      let partnerInput = [];

      //Asia-Pacific
      let countryPartyTemp = [];
      let iso = ["escap"];
      let countryReportListAP = [];
      iso.forEach((isoData) => {
        let tempList = this.countryGroupListRiva2(isoData);
        countryPartyTemp = countryPartyTemp.concat(tempList);
      });
      partnerInput = [...new Set(countryPartyTemp)];
      partnerInput.forEach((item) => {
        let temp = {
          label: item,
        };
        countryReportListAP.push(temp);
      });

      let dataSend = {
        countryReportList: "xxx",
        countryPartnerList: countryReportListAP,
        reportMap: this.input,
        partnerMap: partnerInput,

        input: {
          year: {
            min: this.getStartYear(),
            max: this.getEndYear(),
          },
          type: "Sustainable",
        },
      };
      let url7 = this.ri_api + "economy/intra_eco_integration_by_country.php";
      let res7 = await axios.post(url7, JSON.stringify(dataSend));
      let dimRaw7 = res7.data;
      dimRaw7 = dimRaw7.filter((x) => x.lastValue != 0);
      this.lineSI = [];
      let countYear = this.yearEnd - this.yearStart + 1;
      for (let i = 1; i <= countYear; i++) {
        this.lineSI.push(0);
      }

      dimRaw7.forEach((x) => {
        for (let i = 0; i < countYear; i++) {
          this.lineSI[i] += x.data[i];
        }
      });

      this.lineSI = this.lineSI.map((x) =>
        Number((x / dimRaw7.length).toFixed(2))
      );

      let dataSendCI = {
        countryReportList: "xxx",
        countryPartnerList: countryReportListAP,
        reportMap: this.input,
        partnerMap: partnerInput,

        input: {
          year: {
            min: this.getStartYear(),
            max: this.getEndYear(),
          },
          type: "Conventional",
        },
      };

      let url7C = this.ri_api + "economy/intra_eco_integration_by_country.php";
      let res7C = await axios.post(url7C, JSON.stringify(dataSendCI));
      let dimRaw7C = res7C.data;
      dimRaw7C = dimRaw7C.filter((x) => x.lastValue != 0);
      this.lineCI = [];
      for (let i = 1; i <= countYear; i++) {
        this.lineCI.push(0);
      }
      // this.lineCI = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
      dimRaw7C.forEach((x) => {
        for (let i = 0; i < countYear; i++) {
          this.lineCI[i] += x.data[i];
        }
      });

      this.lineCI = this.lineCI.map((x) =>
        Number((x / dimRaw7C.length).toFixed(2))
      );

      this.loadingHide();
    },
  },
  mounted() {
    this.yearStart = this.getStartYear();
    this.yearEnd = this.getEndYear();
    this.yearHL = this.getHalfLowYear();
    this.yearHH = this.getHalfHighYear();
  },
};
</script>

<style lang="scss" scoped>
.btn {
  width: 240px;
  height: 40px;
}
.bigBtn {
  width: 250px;
  height: 80px;
  border: 1px solid #2d9687;
  border-radius: 10px;
}
</style>
